package jp.ac.ritsumei.is.infobio;
import java.io.*;
import java.util.*;
import java.util.regex.*;
import javax.servlet.*;
import javax.servlet.http.*;
import java.util.concurrent.*;

/**
 * \tOgCI𐶐NXłD
 * @author  m
 * @version  20090127
 */
public class Fragmentation
{
    Glycan gc;                                  // tOgs\
    HashSet<Glycan> hs = new HashSet<Glycan>(); // Jɂ萶S\i[

    /**
     * tOg铜\ǂݍ݂܂D
     * @param gc tOg铜\
     */
    public void setGlycan(Glycan gc)
    {
        this.gc = gc;
    }

    /**
     * tOg̓gԂ܂D
     * @return tOgComposition
     */
    public List<Composition> getComposition() throws Exception
    {
        ArrayList<Composition> temp = new ArrayList<Composition>(); // Jɂ萶gi[
        for (Glycan gc : getGlycan())
        {
            Composition cp = new Composition(gc);
            boolean flag = true;                                    // vffalseƂȂD
            for (Composition temp_cp : temp)
                if (temp_cp.equals(cp))
                    flag = false;

            if (flag)
                temp.add(cp);
        }

        ArrayList<Composition> dehydrate = new ArrayList<Composition>(); // Ê݂̑gi[
        for (Composition temp_cp : temp)
            if (!temp_cp.hasCeramide())                                  // ݂̂̑głꍇC
                dehydrate.add(new Composition(temp_cp + ", -h2o"));      // E𐶐D
        temp.addAll(dehydrate);

        Collections.sort(temp, new Comparator<Composition>() // \[gsD
        {
            public int compare(Composition cp1, Composition cp2)
            {
                double sub = 0.0;
                try
                {
                    sub = cp1.getMass(MassCalc.MONO_MASS, MassCalc.Na_ION)
                        - cp2.getMass(MassCalc.MONO_MASS, MassCalc.Na_ION);
                } catch (Exception e) {/**/}

                return (int)(sub*1024); // compare\bh̕Ԃlint^󂯕tȂ̂1024{ĐxグD
            }
        });

        return temp;
    }

    /**
     * tOg̓\Ԃ܂D
     * @return tOgGlycan
     */
    public List<Glycan> getGlycan() throws Exception
    {
        hs.clear();                                   // 
        frag(gc);                                     // tOgs

        List<Glycan> li = new ArrayList<Glycan>(hs);  // \[g̃f[^Ԃ߂HashSetList֌^ϊD

        ListIterator<Glycan> it = li.listIterator();  // Z~h̑g݂ꍇ
        while (it.hasNext())
        {
            Glycan temp = it.next();
            if (temp.hasCeramide() && temp.size() == 1)
                it.remove();                          // 폜D
        }

        Collections.sort(li, new Comparator<Glycan>() // \[gsD
        {
            public int compare(Glycan gc1, Glycan gc2)
            {
                double sub = 0.0;
                try
                {
                    sub = gc1.getMass(MassCalc.MONO_MASS, MassCalc.Na_ION)
                        - gc2.getMass(MassCalc.MONO_MASS, MassCalc.Na_ION);
                } catch (Exception e)
                {

                }

                return (int)(sub*1024); // compare\bh̕Ԃlint^󂯕tȂ̂1024{ĐxグD
            }
        });

        return li;
    }

    /**
     * tOgs܂D
     * @param root tOgs؍\
     */
    protected void frag(Glycan root) throws Exception
    {
        Glycan gc = new Glycan(root.toString());
        if (!hs.contains(gc))   // J\Listɑ݂Ȃꍇ
        {
            hs.add(gc);         // ArrayList֒ǉ
            search(root, root); // [DTs
        }
    }

    /**
     * GlycanNX̊Jʒu|C^ɑ΂A[DTs܂D
     * @param root TreeNX̃[g
     * @param pointer TreeNX̃|C^
     */
    protected void search(Glycan root, Glycan pointer) throws Exception
    {
        decay(root, pointer);                   // pointervf̉̕ӂŊJ􂳂D

        for (Glycan gc : pointer.getChildren()) // qm[hȂ΁CɒTsD
            search(root, gc);
    }

    /**
     * ؍\root|C^vf̉̕ӂŊJ􂳂܂D
     * @param root J􂳂؍\
     * @param pointer J􂳂ʒu|C^
     */
    protected void decay(Glycan root, Glycan pointer) throws Exception
    {
        ListIterator<Glycan> it = pointer.getChildren().listIterator();
        while (it.hasNext()) // |C^vf̉̕ӂŊJ􂳂D
        {
            Glycan gc = it.next();
            frag(new Glycan(gc.toString()));          // tʂGlycanIuWFNgč\zCċAD
                                                      // rootʂGlycanIuWFNgč\zCċAD
            it.remove();                              // tʂ̐߂菜
            Glycan gc2 = new Glycan(root.toString()); // č\z
            it.add(new Glycan(gc.toString()));        // ɖ߂
            frag(gc2);                                // add͎̗vf΂̗vf̒Oɑ}D
        }
    }
}
