package jp.ac.ritsumei.is.infobio;
import java.util.*;
import java.util.concurrent.*;

/**
 * `KOIVh̃tOgCI\\NXłD
 * @author m
 * @version 20090124
 */
class CandidateGa extends Candidate
{
    Glycan before_gc;                                      // `O̓\i[

    public CandidateGa(Glycan gc) throws Exception
    {
        super();
        before_gc = new Glycan(gc.toString());             // `O̍\i[ĂD

        gc.methylation();                                  // `sD

        this.setNode(gc.getNode());                        // `̍\o^D
        this.setEdge(gc.getEdge());
        this.setChildren(gc.getChildren());

        fg.setGlycan(this);
        this.frags_t  = fg.getComposition();               // ꂼ̃tOg擾D
        this.masses_t = new double[this.frags_t.size()];   // tOgƓTCY̔zp

        int i = 0;
        for (Composition temp : this.frags_t)              // tOg̕qʂvZĂ
            masses_t[i++] = temp.getMass(monoavg, adduct); // `m/zo^D
    }

    /*
     * `O̓\Ԃ܂D
     * @return `O̓\
     */
    public synchronized Glycan getIntactGlycan() throws Exception
    {
        return before_gc;
    }
}

/**
 * `KOIVh̍\\sNXłD
 * @author m
 * @version 20080725
 */
public class PredictionGa extends Prediction
{
    double precursor_me = 0.0;                            // `̐e}X
    CompositionToolsMe cp_agg = new CompositionToolsMe(); // CompositionToolsCompositionToolsMeɃI[o[Ch

    /**
     * RXgN^
     */
    public PredictionGa()
    {
        super();
    }

    /**
     * \ꂽ\Ԃ܂D
     * @return XRAɗ\z\Ԃ܂D
     */
    public java.util.List<? extends Candidate> getPrediction() throws Exception
    {                                                                       // w肳ꂽ\𐶐
        java.util.List<Composition> cps = getCandidateComposition();        // g쐬D
        java.util.List<Glycan> candi = this.getCandidateGlycan(cps);        // \𐶐CXgɊi[D
        java.util.List<CandidateGa> al = this.toCandidateMeInstance(candi); // Glycaň\C
                                                                            // CandidateGǎ\Ƃēo^D
        CandidateGa.setFreq(this.getFreqency(al));                          // omvZCCandidateMeNX
                                                                            // staticϐƂēo^D
        Collections.sort(al, new Comparator<CandidateGa>()                  // XRAɃ\[gD
        {
            public int compare(CandidateGa cp1, CandidateGa cp2)
            {
                double sub = 0.0;                                           // XRA̍
                try
                {
                    double score1 = cp1.getScore();
                    double score2 = cp2.getScore();

                    if (score1 == score2)                                   // XRA\́C򐔂̏Ȃ
                        sub = cp1.countLeaf() - cp2.countLeaf();            // itm[hȂj\ʂɕ\
                    else
                        sub = score2 - score1;
                    
                }
                catch (Exception e)
                {
                    System.err.println("Prediction.getPrediction(): score compare error");
                }

                return (int)(sub*1024);                                     // x1024{ɏグ
            }
        });

        return al;
    }

    /**
     * g𐶐CXgɊi[D
     */
    protected java.util.List<Composition> getCandidateComposition() throws Exception
    {                                    // `O̐e}X݂̂g\DeNX̓tOg\
        java.util.List<Composition> cps; // lgi[郊Xg

        cp_agg.setComposition(known_cp);
        cp_agg.setGlycan(known_gc);
        cp_agg.setMsTolerance(tolerance_ms);

        if (precursor == 0.0)            // e}X̕qʂo^ĂȂꍇC
        {                                // tOgqʂ̍őlvZD
            Arrays.sort(masses_a);       // őlo߂ɏɃ\[gD
            cp_agg.setMass(masses_a[masses_a.length-1]);
            cps = cp_agg.getComposition();
        }
        else                             // e}X̕qʂo^Ăꍇ
        {
            cp_agg.setMass(precursor);
            cps = cp_agg.getComposition();
        }

        ListIterator<Composition> it = cps.listIterator();
        while (it.hasNext())
        {
            Composition cp = new Composition(it.next());
            System.out.println("candidate composition: " + cp);
            if (!cp.contains("neuac"))   // VA_ĂȂgrD
            {
                it.remove();
                System.out.println(cp + " is removed.");
            }
        }

        return cps;
    }

    /**
     * GlycanCX^X̌\CCandidateGaCX^X̌\ƂCtOgsD
     */
    protected java.util.List<CandidateGa> toCandidateMeInstance(java.util.List<Glycan> candi) throws Exception
    {
        java.util.List<CandidateGa> al = new ArrayList<CandidateGa>();  // XRAts\
        long start = new Date().getTime();                              // vOJn
        int candi_size = candi.size();                                  // \i[
        ListIterator<Glycan> it2 = candi.listIterator();                // \̃Ce[^擾
        for (int i = 1; it2.hasNext() && flag; i++)                     // lĝƂ蓾\XgɊi[
        {
            Glycan temp = it2.next();
            it2.remove();                                               // sKvłGlycanCX^X폜D

            percent = (int)(i * 99.0 / candi_size);                     // %i񂾂i[
                                                                        //irŕ\邽99%j
            String messege = progress(i, candi_size, start);            // IuU[oɑ郁bZ[W쐬D
            try
            {
                messege = messege + " [" + temp.toNormalFormat() + "]"; // m[}̃tH[}bgŊi[D
            }
            catch (Exception e)
            {
                messege = messege + " [" + temp.toString() + "]";       // 񕪊ȏ̍\Linucs`Ŋi[D
            }
            this.setChanged();                                          // ύXƂ𖾎D
            this.notifyObservers(messege);                              // Ď҂ɐis󋵂ʒm
            this.clearChanged();                                        // ύXꂽԂłȂƂ𖾎D

            CandidateGa cd = new CandidateGa(temp);
            al.add(cd);
        }

        if (!flag)                                                      // fꂽꍇC
            al.clear();                                                 // CandidateMeCX^X̌\폜
        else                                                            // ɊꍇC
        {
            percent = 100;                                              // ProgressMonitorI邽߂100%ɂD
            this.setChanged();                                          // ύXƂ𖾎D
            this.notifyObservers(progress(candi.size(), candi.size(), start)); // Ď҂ɐis󋵂ʒm
            this.clearChanged();                                        // ύXꂽԂłȂƂ𖾎D
        }

        return al;
    }

    /**
     * GlycanCX^X̌\CCandidateCX^X̌\ƂCtOgsD
     */
    protected java.util.List<CandidateGa> toCandidateMeInstance2(java.util.List<Glycan> candi) throws Exception
    {                                                                   // }`Xbh
        java.util.List<CandidateGa> al = new ArrayList<CandidateGa>();  // XRAts\
        long start = new Date().getTime();                              // vOJn
        int candi_size = candi.size();                                  // \i[
        ListIterator<Glycan> it2 = candi.listIterator();                // \̃Ce[^擾
        for (int i = 1; it2.hasNext() && flag; i++)                     // lĝƂ蓾\XgɊi[
        {
            StringBuffer gc_messege = new StringBuffer();               // ݏ̓𕶎\ɂĊi[
            java.util.List<Glycan> gc_thread = new ArrayList<Glycan>(); // 1̏ŕvZGlycanCX^X
            for (int j = 0; j < 8 && it2.hasNext(); j++)                // 8Xbh񂳂̂ŁC8
            {
                Glycan temp = it2.next();
                try
                {
                    gc_messege.append(temp.toNormalFormat() + ", ");    // m[}̃tH[}bgŊi[
                }
                catch (Exception e)
                {
                    gc_messege.append(temp.toString() + ", ");          // 񕪊ȏ̍\Linucs`Ŋi[
                }
                gc_thread.add(temp);                                    // }`Xbh̃^XNɒǉ
                it2.remove();                                           // sKvłGlycanCX^X폜

                i++;                                                    // ς݂̌𑝉D
            }
            i--;                                                        // for̒Œl1Ȃ邽߁C폜

            System.out.println("!"+i+"/"+candi_size);
            percent = (int)(i * 99.0 / candi_size);                     // %i񂾂i[
                                                                        // rŕ\邽99%
            String messege = progress(i, candi_size, start);            // IuU[oɑ郁bZ[W
            messege = messege + " [" + gc_messege.toString() + "]";
            this.setChanged();                                          // ύXƂ𖾎D
            this.notifyObservers(messege);                              // Ď҂ɐis󋵂ʒm
            this.clearChanged();                                        // ύXꂽԂłȂƂ𖾎D

            java.util.List<Callable<CandidateGa>> tasks = new ArrayList<Callable<CandidateGa>>();
                                                                        // ^XNi[郊Xg
            for (Glycan temp : gc_thread)
            {
                Callable<CandidateGa> task = new MultiThreadTool3(new Glycan(temp));
                tasks.add(task);
            }
            ExecutorService es = Executors.newFixedThreadPool(8);       // 8XbhŎs
            java.util.List<Future<CandidateGa>> futures = es.invokeAll(tasks); // ^XN̎s

            for (Future<CandidateGa> future : futures)                  // sʂ̉
            {
                CandidateGa cd = future.get();
                al.add(cd);
            }
            es.shutdown();                                              // 񏈗̏I
        }

        if (!flag)                                                      // fꂽꍇC
            al.clear();                                                 // CandidateCX^X̌\폜
        else                                                            // ɊꍇC
        {
            percent = 100;                                              // ProgressMonitorI邽߂100%ɂD
            this.setChanged();                                          // ύXƂ𖾎D
            this.notifyObservers(progress(candi.size(), candi.size(), start)); // Ď҂ɐis󋵂ʒm
            this.clearChanged();                                        // ύXꂽԂłȂƂ𖾎D
        }

        return al;
    }

    /**
     * mAC\g[vC܂̓Ax[WŌvZ邩ݒ肵܂D
     * @param monoavg mAC\gsbN܂̓Ax[WD
     */
    public void setMonoavg(boolean monoavg) throws Exception
    {
        CandidateGa.setMonoavg(monoavg); // CandidateNXstaticϐƂēo^D
        cp_agg.setMonoavg(monoavg);      // g\NX̃\bh𗘗pēo^D
    }

    /**
     * \ɗptCIw肵܂D
     * @param adduct tCIiftHgNa+j
     */
    public void setAdduct(String adduct) throws Exception
    {
        CandidateGa.setAdduct(adduct); // CandidateNXstaticϐƂēo^D
        cp_agg.setAdduct(adduct);      // g\NX̃\bh𗘗pēo^D
    }

    /**
     * PSDXyNg̎lƗ_l̋e덷o^܂D
     * @param tolerance_psd lƗ_l̋e덷
     */
    public void setPsdTolerance(double tolerance_psd) throws Exception
    {
        this.tolerance_psd = tolerance_psd;         // NXoƂD
        CandidateGa.setPsdTolerance(tolerance_psd); // CandidateNXstaticϐƂēo^D
    }

    /**
     * tOgqʂ̎lo^܂D
     * @param masses_a tOgqʂ̎l
     */
    public void setFragments(double[] masses_a)
    {
        this.masses_a = masses_a;          // oϐƂĊi[
        CandidateGa.setMasses_a(masses_a); // CandidateNXstaticϐƂēo^D
    }

    /**
     * \ɗpXRAw肵܂D
     * @param formula XRA
     */
    public void setScoringFormula(int formula)
    {
        CandidateGa.setScoringFormula(formula); // CandidateNXstaticϐƂēo^D
    }

    /**
     * omz̃EBhETCYw肵܂D
     * @param window EBhETCY
     */
    public void setWindowSize(int window)
    {
        CandidateGa.setWindowSize(window); // CandidateNXstaticϐƂēo^D
    }

    /**
     * ݓo^Ăomz̃EBhETCY擾܂D
     * @return EBhETCY
     */
    public int getWindowSize()
    {
        return CandidateGa.getWindowSize(); // CandidateNXstaticϐĂяoD
    }


    /**
     * g̗\ɗp钷go^܂D
     * @param lcb g
     */
    public void setLongChainBase(java.util.List<String> lcb) throws Exception
    {
        cp_agg.setLongChainBase(lcb);
    }

    /**
     * g̗\ɗp鎉b_go^܂D
     * @param fa b_g
     */
    public void setFattyAcid(java.util.List<String> fa) throws Exception
    {
        cp_agg.setFattyAcid(fa);
    }

    /**
     * g̗\ɗp钷go^܂D
     * @param min Yf̍ŏl
     * @param max Yf̍ől
     */
    public void setLongChainBase(int min, int max) throws Exception
    {
        cp_agg.setLongChainBase(min, max);
    }

    /**
     * g̗\ɗp鎉b_go^܂D
     * @param min Yf̍ŏl
     * @param max Yf̍ől
     */
    public void setFattyAcid(int min, int max, int bond) throws Exception
    {
        cp_agg.setFattyAcid(min, max, bond);
    }

    /**
     * g̗\ɗpZ~hgo^܂D
     * @param ceramide Z~hg
     */
    public void setCeramide(java.util.List<String> ceramide) throws Exception
    {
        cp_agg.setCeramide(ceramide);
    }

    /**
     * g̗\ɗpZ~hgo^܂D
     * @param min Yf̍ŏl
     * @param max Yf̍ől
     * @param bond b_̓d̍ől
     */
    public void setCeramide(int min, int max, int bond)
    {
        cp_agg.setCeramide(min, max, bond);
    }

    /**
     * \ōle̓w肵܂D
     * @param str w肷铜
     * @param max w肷铜
     */
    public void setMax(String str, int max) throws Exception
    {
        cp_agg.setMax(str, max);
    }

    /**
     * \ōle̓w肵܂D
     * @param str w肷铜
     * @param bl  𑶍݂邩w
     */
    public void setMax(String str, boolean bl) throws Exception
    {
        cp_agg.setMax(str, bl);
    }
}

class MultiThreadTool3 implements Callable<CandidateGa>
{
    Glycan gc;                      // 񏈗̂߂ɕۑĂ\

    public MultiThreadTool3(Glycan gc) throws Exception
    {
        this.gc = gc;               // \o^
    }

    public CandidateGa call() throws Exception
    {
        return new CandidateGa(gc); // tOg̕qʂ̌vZς݂̌\ԂD
    }
}