package jp.ac.ritsumei.is.infobio;
import java.util.*;

/**
 * `㓜̃tOgCI\\NXłD
 * @author m
 * @version 20090128
 */
class CandidateMe extends Candidate
{
    Glycan before_gc;                                          // `O̓\i[
    static double precursor_me;                                // `̃vJ[T[}X

    public CandidateMe(Glycan gc) throws Exception
    {
        super();                                               // ȂX[p[NX̃RXgN^
        before_gc = new Glycan(gc.toString());                 // `O̍\i[ĂD

        gc.methylation();                                      // `sD

        this.setNode(gc.getNode());                            // `̍\o^D
        this.setEdge(gc.getEdge());
        this.setChildren(gc.getChildren());

        double ceramide_remove;                                // `̗_lƎlC
        if (precursor_me != 0.0)                               // Z~h̕qʂǂꂾvZD
            ceramide_remove = this.getMass(monoavg, adduct) - precursor_me;
        else                                                   // `̎lo^ĂȂꍇ́CO
            throw new Exception("Error: Set mathylated precursor mass, use setPrecursorMeMass()");

        fg.setGlycan(this);
        this.frags_t  = fg.getComposition();                   // ꂼ̃tOg擾
        this.masses_t = new double[this.frags_t.size()];       // tOgƓTCY̔zp

        int i = 0;
        for (Composition temp : this.frags_t)                  // tOg̕qʂvZĂ
            if (temp.hasCeramide())                            // Z~h݂ꍇ́C덷l
                masses_t[i++] = temp.getMass(monoavg, adduct) - ceramide_remove;
            else
                masses_t[i++] = temp.getMass(monoavg, adduct); // ̂܂܃`m/zo^D
    }

    /**
     * `̐e}Xo^܂D
     * @param precursor_me `̐e}X
     */
    public static void setPrecursorMeMass(double precursor_me)
    {
        CandidateMe.precursor_me = precursor_me;               // oϐƂĊi[
    }

    /*
     * `O̓\Ԃ܂D
     * @return `O̓\
     */
    public Glycan getIntactGlycan()
    {
        return before_gc;
    }
}

/**
 * `̍\\sNXłD
 * @author m
 * @version 20080725
 */
public class PredictionMe extends Prediction
{
    double precursor_me = 0.0;                            // `̐e}X
    CompositionToolsMe cm_agg = new CompositionToolsMe(); // C^Ng̃vJ[T[}X͂Ȃ̏ꍇɗpD

    /**
     * RXgN^
     */
    public PredictionMe()
    {
        super();
    }

    /**
     * mAC\g[vC܂̓Ax[WŌvZ邩ݒ肵܂D
     * @param monoavg mAC\gsbN܂̓Ax[WD
     */
    public void setMonoavg(boolean monoavg) throws Exception
    {
        Candidate.setMonoavg(monoavg);                   // CandidateNXstaticϐƂēo^
        cp_agg.setMonoavg(monoavg);                      // g\NX̃\bh𗘗pēo^
        cm_agg.setMonoavg(monoavg);                      // g\NX̃\bh𗘗pēo^
    }

    /**
     * \ɗptCIw肵܂D
     * @param adduct tCIiftHgNa+j
     */
    public void setAdduct(String adduct) throws Exception
    {
        Candidate.setAdduct(adduct);                     // CandidateNXstaticϐƂēo^
        cp_agg.setAdduct(adduct);                        // g\NX̃\bh𗘗pēo^
        cm_agg.setAdduct(adduct);                        // g\NX̃\bh𗘗pēo^
    }

    /**
     * g̗\ɗp钷go^܂D
     * @param lcb g
     */
    public void setLongChainBase(java.util.List<String> lcb) throws Exception
    {
        cp_agg.setLongChainBase(lcb);
        cm_agg.setLongChainBase(lcb);
    }

    /**
     * g̗\ɗp鎉b_go^܂D
     * @param fa b_g
     */
    public void setFattyAcid(java.util.List<String> fa) throws Exception
    {
        cp_agg.setFattyAcid(fa);
        cm_agg.setFattyAcid(fa);
    }

    /**
     * g̗\ɗp钷go^܂D
     * @param min Yf̍ŏl
     * @param max Yf̍ől
     */
    public void setLongChainBase(int min, int max) throws Exception
    {
        cp_agg.setLongChainBase(min, max);
        cm_agg.setLongChainBase(min, max);
    }

    /**
     * g̗\ɗp鎉b_go^܂D
     * @param min Yf̍ŏl
     * @param max Yf̍ől
     */
    public void setFattyAcid(int min, int max, int bond) throws Exception
    {
        cp_agg.setFattyAcid(min, max, bond);
        cm_agg.setFattyAcid(min, max, bond);
    }

    /**
     * g̗\ɗpZ~hgo^܂D
     * @param ceramide Z~hg
     */
    public void setCeramide(java.util.List<String> ceramide) throws Exception
    {
        cp_agg.setCeramide(ceramide);
        cm_agg.setCeramide(ceramide);
    }

    /**
     * g̗\ɗpZ~hgo^܂D
     * @param min Yf̍ŏl
     * @param max Yf̍ől
     * @param bond b_̓d̍ől
     */
    public void setCeramide(int min, int max, int bond)
    {
        cp_agg.setCeramide(min, max, bond);
        cm_agg.setCeramide(min, max, bond);
    }

    /**
     * \ōle̓w肵܂D
     * @param str w肷铜
     * @param max w肷铜
     */
    public void setMax(String str, int max) throws Exception
    {
        cp_agg.setMax(str, max);
        cm_agg.setMax(str, max);
    }

    /**
     * \ōle̓w肵܂D
     * @param str w肷铜
     * @param bl  𑶍݂邩w
     */
    public void setMax(String str, boolean bl) throws Exception
    {
        cp_agg.setMax(str, bl);
        cm_agg.setMax(str, bl);
    }

    /**
     * `̐e}Xo^܂D
     * @param precursor_me `̐e}X
     */
    public void setPrecursorMeMass(double precursor_me)
    {
        this.precursor_me = precursor_me;             // oϐƂĊi[
        CandidateMe.setPrecursorMeMass(precursor_me); // CandidateMẽX^eBbNϐƂĂo^
    }

    // g𐶐CXgɊi[D
    protected java.util.List<Composition> getCandidateCompositionMe() throws Exception
    {
        System.out.print("canndidate compositions are predicting from only premethylaed precursor mass, ");
        System.out.println("because intact precusor mass is null.");
        java.util.List<Composition> cps;              // lgi[郊Xg

        cm_agg.setComposition(known_cp);
        cm_agg.setGlycan(known_gc);
        cm_agg.setMsTolerance(tolerance_ms);
        cm_agg.setMass(precursor_me);
        cps = cm_agg.getComposition();

        return cps;
    }

    /**
     * \ꂽ\Ԃ܂D
     * @return XRAɗ\z\Ԃ܂D
     */
    public java.util.List<? extends Candidate> getPrediction() throws Exception
    {   // w肳ꂽ\𐶐܂D
        java.util.List<Composition> cps;
        if (precursor == 0.0)                         // C^Ng̃vJ[T[}Xo^ĂȂꍇC
            cps = getCandidateCompositionMe();        // `̃vJ[T[}X݂̂g쐬
        else
            cps = getCandidateComposition();                                // ݂Ăꍇ́C\

        java.util.List<Glycan> candi = this.getCandidateGlycan(cps);        // \𐶐CXgɊi[
        java.util.List<CandidateMe> al = this.toCandidateMeInstance(candi); // Glycaň\C
                                                                            // CandidateMě\Ƃēo^
        CandidateMe.setFreq(this.getFreqency(al));                          // omvZC
                                                                            // CandidateMeNXstaticϐƂēo^
        Collections.sort(al, new Comparator<CandidateMe>()                  // XRAɃ\[g
        {
            public int compare(CandidateMe cp1, CandidateMe cp2)
            {
                double sub = 0.0; // XRA̍
                try
                {
                    double score1 = cp1.getScore();
                    double score2 = cp2.getScore();

                    if (score1 == score2)                                   // XRA\́C򐔂̏Ȃ
                        sub = cp1.countLeaf() - cp2.countLeaf();            // itm[hȂj\ʂɕ\
                    else
                        sub = score2 - score1;
                    
                }
                catch (Exception e)
                {
                    System.err.println("Prediction.getPrediction(): score compare error");
                }

                return (int)(sub*1024);                                     // x1024{ɏグ
            }
        });

        return al;
    }

    /**
     * g𐶐CXgɊi[D
     */
    protected java.util.List<Composition> getCandidateComposition() throws Exception
    {   // `O̐e}X݂̂g\DeNX̓tOg\
        java.util.List<Composition> cps;                                    // lgi[郊Xg

        cp_agg.setComposition(known_cp);
        cp_agg.setGlycan(known_gc);
        cp_agg.setMsTolerance(tolerance_ms);

        if (precursor == 0.0)                                               // e}X̕qʂo^ĂȂꍇC
        {                                                                   // tOgqʂ̍őlvZ
            Arrays.sort(masses_a);                                          // őlo߂ɏɃ\[g
            cp_agg.setMass(masses_a[masses_a.length-1]);
            cps = cp_agg.getComposition();
        }
        else                                                                // e}X̕qʂo^Ăꍇ
        {
            cp_agg.setMass(precursor);
            cps = cp_agg.getComposition();
        }

        ListIterator<Composition> it = cps.listIterator();
        while (it.hasNext())
        {
            Composition cp = new Composition(it.next());

            int count = cp.countHydroxy();
            for (int i = 0; i < count; i++)                                 // qhLV̌̃`t
                cp.add("me");

            double mass = cp.getMass(true, MassCalc.Na_ION); // _̃`Ǝ̃`Ƃ̌덷C
            if (Math.abs(mass - precursor_me) > 20.0)        // w肵ȏ̑gg珜OD
            {
                System.out.println(cp + "is removed." + mass + "-" + precursor_me + "=" + (mass - precursor_me));
                it.remove();                                 // `1̂߁Ce덷14`28Da͈̔͂̒l20.0
            }
        }

        return cps;
    }

    /**
     * GlycanCX^X̌\CCandidateMeCX^X̌\ƂCtOgsD
     */
    protected java.util.List<CandidateMe> toCandidateMeInstance(java.util.List<Glycan> candi) throws Exception
    {
        java.util.List<CandidateMe> al = new ArrayList<CandidateMe>();  // XRAts\
        long start = new Date().getTime();                              // vOJn
        int candi_size = candi.size();                                  // \i[
        ListIterator<Glycan> it2 = candi.listIterator();                // \̃Ce[^擾
        for (int i = 1; it2.hasNext() && flag; i++)                     // lĝƂ蓾\XgɊi[
        {
            Glycan temp = it2.next();
            it2.remove();                                               // sKvłGlycanCX^X폜

            percent = (int)(i * 99.0 / candi_size);                     // %i񂾂i\邽99%j
            String messege = progress(i, candi_size, start);            // IuU[oɑ郁bZ[W쐬D
            try
            {
                messege = messege + " [" + temp.toNormalFormat() + "]"; // m[}̃tH[}bgŊi[D
            }
            catch (Exception e)
            {
                messege = messege + " [" + temp.toString() + "]";       // 񕪊ȏ̍\Linucs`Ŋi[D
            }
            this.setChanged();                                          // ύXƂ𖾎D
            this.notifyObservers(messege);                              // Ď҂ɐis󋵂ʒm
            this.clearChanged();                                        // ύXꂽԂłȂƂ𖾎D

            CandidateMe cd = new CandidateMe(temp);
            al.add(cd);
        }

        if (!flag)                                                      // fꂽꍇC
            al.clear();                                                 // CandidateMeCX^X̌\폜
        else                                                            // ɊꍇC
        {
            percent = 100;                                              // ProgressMonitorI邽߂100%ɂD
            this.setChanged();                                          // ύXƂ𖾎D
            this.notifyObservers(progress(candi.size(), candi.size(), start)); // Ď҂ɐis󋵂ʒm
            this.clearChanged();                                        // ύXꂽԂłȂƂ𖾎D
        }

        return al;
    }

    /**
     * tOg̏om̌vZlԂ܂D
     */
    public double[] getFreqency(java.util.List<? extends Candidate> al) throws Exception
    {
        double[] freq;                                                  // returnmz

        if (precursor_me == 0.0)                                        // e}X̕qʂo^ĂȂꍇC
        {                                                               // tOgqʂ̍őlvZ
            Arrays.sort(masses_a);                                      // őlo߂ɏɃ\[gD
            freq = new double[(int)(masses_a[masses_a.length-1]/this.getWindowSize())+100]; // 1DaopxvZ
        }
        else                                                                 // e}X̕qʂo^Ăꍇ
            freq = new double[(int)(precursor_me/this.getWindowSize())+100]; // 1DaopxvZD

        for (Candidate cd : al)
        {
            boolean[] check = new boolean[freq.length];                      // 1\ŏdȂ悤ɂtbO

            double[] masses = cd.getFragMasses();
            for (int i = 0; i < masses.length; i++)                          // ꂼ̃tOg擾C
            {                                                                // tOg݂trueƂD
                if ((int)(masses[i]/this.getWindowSize()) > 0)
                    check[(int)(masses[i]/this.getWindowSize()) - 1] = true; // ÕtbO𗧂ĂD

                check[(int)(masses[i]/this.getWindowSize())] = true;         // ݂̈ʒũtbO𗧂ĂD

                if (i+1 < freq.length)
                    check[(int)(masses[i]/this.getWindowSize()) + 1] = true; // ̃tbOĂD
            }

            for (int i = 0; i < freq.length; i++)                            // tbOom̔zփRs[
                if (check[i])                                                // tOg݂1
                    freq[i] += 1.0;
        }

        double max = 1.0;                                                    // 0ŊȂ߂ɏl1
        for (double temp : freq)                                             // őlTD
            max = Math.max(temp,max);

        for (int i = 0; i < freq.length; i++)                                // őlŊ邱Ƃ
            freq[i] = freq[i] / max;                                         // 0.0`1.0Ƃ悤ɕϊ

        return freq;
    }
}
